Next: ATOMIC_XOR, Previous: ATOMIC_OR, Up: Intrinsic Procedures [Contents][Index]

### 9.37 `ATOMIC_REF` — Obtaining the value of a variable atomically

Description:

  `ATOMIC_DEFINE(ATOM, VALUE)` atomically assigns the value of the variable ATOM to VALUE. When STAT is present and the invocation was successful, it is assigned the value 0. If it is present and the invocation has failed, it is assigned a positive value; in particular, for a coindexed ATOM, if the remote image has stopped, it is assigned the value of `ISO_FORTRAN_ENV`’s `STAT_STOPPED_IMAGE` and if the remote image has failed, the value `STAT_FAILED_IMAGE`.

Standard:

  Fortran 2008 and later; with STAT, TS 18508 or later

Class:

  Atomic subroutine

Syntax:

  `CALL ATOMIC_REF(VALUE, ATOM [, STAT])`

Arguments:

  VALUE | Scalar of the same type as ATOM. If the kind is different, the value is converted to the kind of ATOM.
  ATOM | Scalar coarray or coindexed variable of either integer type with `ATOMIC_INT_KIND` kind or logical type with `ATOMIC_LOGICAL_KIND` kind.
  STAT | (optional) Scalar default-kind integer variable.

Example:

      program atomic
        use iso_fortran_env
        logical(atomic_logical_kind) :: atom[*]
        logical :: val
        call atomic_ref (atom, .false.)
        ! ...
        call atomic_ref (atom, val)
        if (val) then
          print *, "Obtained"
        end if
      end program atomic

See also:

  ATOMIC_DEFINE, ATOMIC_CAS, ISO_FORTRAN_ENV, ATOMIC_FETCH_ADD, ATOMIC_FETCH_AND, ATOMIC_FETCH_OR, ATOMIC_FETCH_XOR